﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace HornetQIssue
{
    class Program
    {
        // Summary:
        //     Represents the method that executes on a System.Threading.Thread.
        //
        // Parameters:
        //   obj:
        //     An object that contains data for the thread procedure.

        static void Main(string[] args)
        {
            int loop = 0;
            bool foundException = false;
            while (!foundException)
            {
                Console.WriteLine("Trip #{0}", ++loop);
                Console.WriteLine("Sending Message A and Message B to queues");
                
                string serverName = System.Configuration.ConfigurationSettings.AppSettings["server"];
                string primaryQueue = System.Configuration.ConfigurationSettings.AppSettings["primaryQueue"];
                string secondaryQueue = System.Configuration.ConfigurationSettings.AppSettings["secondaryQueue"];
                int waitTimeout = Int32.Parse(System.Configuration.ConfigurationSettings.AppSettings["waitTimeout"]);

                ThreadedInteraction threadedInteraction = new ThreadedInteraction();
                ThreadParams paramS = new ThreadParams(serverName, primaryQueue, secondaryQueue, waitTimeout);
                ThreadParams paramA = new ThreadParams(serverName, primaryQueue, secondaryQueue, waitTimeout);
                ThreadParams paramB = new ThreadParams(serverName, secondaryQueue, null, waitTimeout);

                //Console.WriteLine("*** Here's your chance to kill the app. ***");
                //System.Threading.Thread.Sleep(wait);
                //Console.WriteLine("*** Your chance has passed! ***");
                threadedInteraction.StartSender(paramS);

                //Console.WriteLine("*** Here's your chance to kill the app. ***");
                //System.Threading.Thread.Sleep(wait);
                //Console.WriteLine("*** Your chance has passed! ***");
                threadedInteraction.StartReceiver(paramA);
                paramA.interaction.Dispose();
                threadedInteraction.StartReceiver(paramB);
                paramB.interaction.Dispose();
                paramS.interaction.Dispose();

                foundException = (!paramA.interaction.Signaled(0) || !paramB.interaction.Signaled(0));
            }
            Console.WriteLine("*** Press any key. ***");
            Console.ReadKey();
        }
    }
}
