﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace HornetQIssue
{
    class ThreadedInteraction
    {
        public void ThreadedReceiver(object obj)
        {
            ThreadParams paramData = obj as ThreadParams;

            Console.WriteLine("Receiver is connecting and listening to queue(s)");
            paramData.interaction = new Interaction();
            if (paramData.secondaryQueue != null)
            {
                paramData.interaction.Listen(paramData.server, paramData.primaryQueue, new string[] { "Message A" }, new string[] { "Message A" }, "RecieverA");
                paramData.interaction.Listen(paramData.server, paramData.secondaryQueue, new string[] { "Message B" }, null, "RecieverB");
            }
            else
            {
                paramData.interaction.Listen(paramData.server, paramData.primaryQueue, new string[] { "Message B" }, new string[] { "Message B" }, "RecieverB");
            }
            Console.WriteLine("Receiver is waiting for receipt of Message");
            Console.WriteLine("Receiver.Signaled() == {0}", paramData.interaction.Signaled(paramData.waitTimeout));
            paramData.interaction.Dispose();
        }

        public void ThreadedSender(object obj)
        {
            ThreadParams paramData = obj as ThreadParams;

            paramData.interaction = new Interaction();
            string msgIDA = paramData.interaction.Send(paramData.server, paramData.primaryQueue, "Message A");
            Console.WriteLine("Message A ID:{0}", msgIDA);
            string msgIDB = paramData.interaction.Send(paramData.server, paramData.secondaryQueue, "Message B");
            Console.WriteLine("Message B ID:{0}", msgIDB);
        }

        public void StartSender(ThreadParams paramData)
        {
            Start(paramData, this.ThreadedSender);
        }

        public void StartReceiver(ThreadParams paramData)
        {
            Start(paramData, this.ThreadedReceiver);
        }

        protected void Start(ThreadParams paramData, ParameterizedThreadStart start)
        {
            Thread thread = new Thread(start);
            thread.Start(paramData);
            thread.Join();
        }
    }
}
