﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Apache.NMS;
using Apache.NMS.Util;
using Apache.NMS.Stomp;
using StompCommands = Apache.NMS.Stomp.Commands;

namespace HornetQIssue
{
    class Test
    {

        static void Main(String[] args)
        {
            IConnectionFactory factory;
            IConnection connection;
            ISession session;
            IMessageConsumer consumer;
            String waiting = "";
            String server = "tcp://1.1.1.1:61613";
            String queueName = "exampleA";
            Boolean waitforAck = false;
            int cnt = 0;

            while (true)
            {
                factory = new Apache.NMS.Stomp.ConnectionFactory(server);
                //Create the connection 
                connection = factory.CreateConnection();
                connection.AcknowledgementMode = AcknowledgementMode.ClientAcknowledge;
                connection.Start();

                //Create the Session 
                session = connection.CreateSession();

                Console.WriteLine("Creating producer");
                IMessageProducer producer = null;
                //Needs this naming convention
                producer = session.CreateProducer(new Apache.NMS.Stomp.Commands.Queue("/queue/" + queueName));
                //Send Messages 
                ITextMessage msg = producer.CreateTextMessage("message" + cnt);

                if (!waitforAck)
                {
                    Console.WriteLine("Sending message : " + msg.Text);
                    producer.Send(msg);//, MsgDeliveryMode.Persistent, MsgPriority.Normal, TimeSpan.MinValue);
                    waiting = msg.Text;
                    waitforAck = true;
                }

                Console.WriteLine("Creating consumer");
                consumer = session.CreateConsumer(new Apache.NMS.Stomp.Commands.Queue(queueName), null);
                ITextMessage received = consumer.Receive() as ITextMessage;
                Console.WriteLine("Received message : " + received.Text);

                if (received.Text.Equals(waiting))
                {

                    Console.WriteLine("ACKing");
                    received.Acknowledge();
                    cnt++;
                    waitforAck = false;
                }

                producer.Close();
                producer = null;
                consumer.Close();
                consumer = null;
                session.Close();
                connection.Close();
                session = null;
                connection = null;
                factory = null;
            }
        }

    }
}
